Ext.define("Enjoy.view.Main", {
	extend: 'Ext.tab.Panel',
	id: 'Main',
	requires: ['Ext.TitleBar'],
	config: {
		tabBarPosition: 'bottom',
		ui: 'dark',
		cls:'custom_bottombar',
		//activeItem: 1,
		items: [
			{ xtype: 'Home', listeners: { activate: function(){ Ext.getCmp('Main').getTabBar().hide(); } } },
			{ xtype: 'Lesrooster', listeners: { activate: function(){ Ext.getCmp('Main').getTabBar().show(); } } },
			{ xtype: 'Contact', listeners: { activate: function(){ Ext.getCmp('Main').getTabBar().show(); } } },
			{ xtype: 'Updates', listeners: {
				activate: function(){ 
					if(first_load == 0){ update_all(); }else{ first_load = 0; }
					Ext.getCmp('Main').getTabBar().show(); 
				}
			} }
		],
		listeners: {
			activate: function(){ show_data(); },
		}
	}
});

Ext.define('Home', {
	extend: 'Ext.Panel',
	xtype: 'Home',
	id: 'Home',
	config: {
		title: 'Home',
		iconCls: 'home',
		layout: 'fit',
		items: [
			{	
				xtype: 'container',
				layout: 'vbox',
				scrollable: true,
				items:[
					{
						xtype: 'toolbar',
						docked: 'top',
						type: 'vbox',
						title: 'Enjoy rooster app',
						cls:'custom_topbar',
						items: [
							{ xtype: 'container', cls: 'header_img' },
							{ xtype:'spacer', flex: 1 },
							{ xtype: 'container', cls: 'header_img' }
						]
					},
					{ 
						xtype: 'button',
						text: 'Lesrooster',
						id: 'btn_lesrooster',
						cls: 'main_btn',
						handler: function(){ Ext.getCmp('Main').setActiveItem(1); }
					},
					{ 
						xtype: 'button',
						text: 'Contact',
						id: 'btn_contact',
						cls: 'main_btn',
						handler: function(){ Ext.getCmp('Main').setActiveItem(2); }
					},
					{ 
						xtype: 'button',
						text: 'Nieuws',
						id: 'btn_nieuws',
						cls: 'main_btn',
						handler: function(){ Ext.getCmp('Main').setActiveItem(3); }
					}
				]
			}
		]
	}
});

Ext.define('Lesrooster', {
	extend: 'Ext.Panel',
	xtype: 'Lesrooster',
	id: 'Lesrooster',
	requires: ['Ext.SegmentedButton', 'Ext.carousel.Carousel' ],
	config: {
		title: 'Lesrooster',
		iconCls: 'calendar2',
		iconMask: true,
	    layout:'fit',
		items: [
			{
				xtype: 'toolbar',
				docked: 'top',
				type: 'vbox',
				title: 'Lesrooster',
				cls:'custom_topbar',
				items: [
					{ xtype: 'container', cls: 'header_img' },
					{ xtype:'spacer', flex: 1 },
					{ xtype: 'container', cls: 'header_img' }
				]
			},
        	{
				xtype: 'toolbar',
        		docked: 'top',
				ui: 'neutral',
				height: 45,
        		items: [
					{
						xtype: 'segmentedbutton',
						id: 'dagen',
	        	        allowDepress: false,
						centered: true,
						items: [
							{ text: 'Ma', id: '0', handler: function(){ Ext.getCmp('content-card').animateActiveItem(parseInt(this.id)); }},
							{ text: 'Di', id: '1', handler: function(){ Ext.getCmp('content-card').animateActiveItem(parseInt(this.id)); }},
							{ text: 'Wo', id: '2', handler: function(){ Ext.getCmp('content-card').animateActiveItem(parseInt(this.id)); }},
							{ text: 'Do', id: '3', handler: function(){ Ext.getCmp('content-card').animateActiveItem(parseInt(this.id)); }},
							{ text: 'Vr', id: '4', handler: function(){ Ext.getCmp('content-card').animateActiveItem(parseInt(this.id)); }},
							{ text: 'Za', id: '5', handler: function(){ Ext.getCmp('content-card').animateActiveItem(parseInt(this.id)); }},
							{ text: 'Zo', id: '6', handler: function(){ Ext.getCmp('content-card').animateActiveItem(parseInt(this.id)); }}
	               		]
					}
				]
			},
			{   		
				xtype: 'carousel',
				id: 'content-card',
				directionLock: true,
				onDrag: function(e) {

    			    if (!this.isDragging) { return; }

        			var startOffset = this.dragStartOffset,
        		    direction = this.getDirection(),
        		    delta = direction === 'horizontal' ? e.deltaX : e.deltaY,
        		    lastOffset = this.offset,
        		    flickStartTime = this.flickStartTime,
        		    dragDirection = this.dragDirection,
        		    now = Ext.Date.now(),
        		    currentActiveIndex = this.getActiveIndex(),
        		    maxIndex = this.getMaxItemIndex(),
        		    lastDragDirection = dragDirection,
        		    offset;

        			if ((currentActiveIndex === 0 && delta > 0) || (currentActiveIndex === maxIndex && delta < 0)) { delta *= 0.5; }

        			offset = startOffset + delta;

        			if (offset > lastOffset) {
        			    dragDirection = 1;
        			}else if (offset < lastOffset) {
        			    dragDirection = -1;
        			}

        			if (dragDirection !== lastDragDirection || (now - flickStartTime) > 300) {
        	    		this.flickStartOffset = lastOffset;
        	    		this.flickStartTime = now;
        			}
	
	        		this.dragDirection = dragDirection;
	
	        		// now that we have the dragDirection, we should use that to check if there
	        		// is an item to drag to
	        		if ((dragDirection == 1 && currentActiveIndex == 0) || (dragDirection == -1 && currentActiveIndex == maxIndex)) { return; }
	
	        		this.setOffset(offset);
	    		},
	
				layout: 'fit',
				listeners: {
					activeitemchange: function (tabPanel, tab, oldTab) {
						current_day = this.getActiveIndex();

						if(Ext.getCmp('dagen') != undefined){
							Ext.getCmp('dagen').setPressedButtons(current_day);
						
							// Scroll items to top
							for (var i=0;i<dagen_array.length;i++){ Ext.getCmp(dagen_array[i]).getScrollable().getScroller().scrollTo(0, 0, true); }
						}
					},
				},
				indicator: false,
				defaults: {
					padding: 0,
					margin: 0,
					styleHtmlContent: false,
					scrollable: { 
						//'vertical',
			            direction: 'vertical',
        			    directionLock: true,
					},
					cls: 'lesrooster_html'
				},
				items: [
					{ id: 'Maandag', xtype: 'panel'},
					{ id: 'Dinsdag', xtype: 'panel'},
					{ id: 'Woensdag', xtype: 'panel'},
					{ id: 'Donderdag', xtype: 'panel'},
					{ id: 'Vrijdag', xtype: 'panel'},
					{ id: 'Zaterdag', xtype: 'panel'},
					{ id: 'Zondag', xtype: 'panel'},
				]
			}
		]
	}
});

Ext.define('Contact', {
	extend: 'Ext.Panel',
	xtype: 'Contact',
	config: {
		layout: 'fit',
		title: 'Contact',
		iconCls: 'phone2',
		iconMask: true,
		id: 'Contact',
		styleHtmlContent: false,
		scrollable: true,
		cls: 'default_html',
		items: {
			xtype: 'toolbar',
			docked: 'top',
			type: 'vbox',
			title: 'Contact',
			cls:'custom_topbar',
			items: [
				{ xtype: 'container', cls: 'header_img' },
				{ xtype:'spacer', flex: 1 },
				{ xtype: 'container', cls: 'header_img' }
			]
		},
		html: '',
	}
});

Ext.define('Updates', {
	extend: 'Ext.Panel',
	xtype: 'Updates',
	config: {
		layout: 'fit',
		title: 'Nieuws',
		iconCls: 'info',
		styleHtmlContent: false,
		scrollable: true,
		id: 'Updates',
		cls: 'default_html',
		items: {
			xtype: 'toolbar',
			docked: 'top',
			type: 'vbox',
			title: 'Nieuws',
			cls:'custom_topbar',
			items: [
				{ xtype: 'container', cls: 'header_img' },
				{ xtype:'spacer', flex: 1 },
				{ xtype: 'container', cls: 'header_img' }
			]
		},
		html: '',      
	}
});
