dagen_array = new Array("Maandag","Dinsdag", "Woensdag", "Donderdag", "Vrijdag", "Zaterdag", "Zondag");

var pushNotification;
device_token = '';

// handle APNS notifications for iOS
function onNotificationAPN(e) {}
            
// handle GCM notifications for Android
function onNotificationGCM(e) {
                
	switch(e.event){

		case 'registered':
			if ( e.regid.length > 0 ){ store_device_token({ 'device_token': e.regid }); }
			break;
                  
		default:
			break;
	}
}
            
// Notification handlers
function tokenHandler (result) { store_device_token({ 'device_token': result }); }
function successHandler (result) {}
function errorHandler (error) {}


// STORE DEVICE TOKEN
function store_device_token(object){

	// LOAD THE FIRST RECORD
	record = local_instellingen.first();

	// VARS
	device_token = object.device_token;
	old_device_token = (record == undefined) ? "" : record.data.device_token;
	
	// CHECK IF THE TOKEN HAS CHANGED
	if(device_token != old_device_token){

		// SET SUBMIT DATA
		var submit_data = { 'device_token': device_token, 'old_device_token': old_device_token };
		var url = 'http://app.elseonline.nl/enjoy/receive_token.php';

		// MAKE THE SUBMIT
		Ext.Ajax.request({
			url: url,				
			jsonData : Ext.JSON.encode(submit_data),
			useDefaultXhrHeader: false,
			success: function(response) {
					
				// STORE THE NEW DEVICE TOKEN
				if(record == undefined){
					local_instellingen.add({ 'device_token': device_token });
				}else{
					record.set({ 'device_token': device_token });
				}
						
				local_instellingen.sync();
			}
		});
	}
}


// UPDATE LESROOSTER FUNCTIONS
function delete_old_lesrooster(newdata){
	local_lesrooster.removeAll();
	local_lesrooster.sync();
	create_new_lesrooster(newdata)	
}
		
function create_new_lesrooster(newdata){
			
	import_lesrooster_array = [];
			
	Ext.Array.each(newdata, function(rec, index) {
		import_lesrooster_array.push({'dag': rec.data.dag, 'grote_zaal': rec.data.grote_zaal, 'kleine_zaal': rec.data.kleine_zaal, 'fitness_zaal': rec.data.fitness_zaal });	
	});		
			
	local_lesrooster.add(import_lesrooster_array);
	local_lesrooster.sync();
	lesrooster_updated = true;
}

// UPDATE LESSEN FUNCTIONS	
function delete_old_lessen(newdata){
	local_lessen.removeAll();
	local_lessen.sync();
	create_new_lessen(newdata)	
}
		
function create_new_lessen(newdata){
			
	import_lessen_array = [];
			
	Ext.Array.each(newdata, function(rec, index) {
		import_lessen_array.push({'les_id': rec.data.id, 'les': rec.data.les.replace(/\[TM\]/g, "&trade;"), 'content': rec.data.content });	
	});		
			
	local_lessen.add(import_lessen_array);
	local_lessen.sync();
	lessen_updated = true;

}

// UPDATE UPDATES FUNCTIONS
function delete_old_updates(newdata){
	local_updates.removeAll();
	local_updates.sync();
	create_new_updates(newdata)	
}
		
function create_new_updates(newdata){
			
	import_updates_array = [];
			
	Ext.Array.each(newdata, function(rec, index) {
	
		var date_parts = rec.data.date.split('-');
		var fixed_date = date_parts[2] + '-' + date_parts[1] + '-' + date_parts[0];
	
		import_updates_array.push({'update_id': rec.data.id, 'date': fixed_date, 'title': rec.data.title.replace(/[TM]/g, "&trade;"), 'content': rec.data.content });					
	});		
			
	local_updates.add(import_updates_array);
	local_updates.sync();
	updates_updated = true;

}
		
// UPDATE CONTACT FUNCTIONS
function delete_old_contact(newdata){
	local_contact.removeAll();
	local_contact.sync();
	create_new_contact(newdata);
}
		
function create_new_contact(newdata){
			
	import_contact_array = [];
			
	Ext.Array.each(newdata, function(rec, index) {
		import_contact_array.push({'contact_id': rec.data.id, 'content': rec.data.content });			
	});		
		
	local_contact.add(import_contact_array);
	local_contact.sync();
	contact_updated = true;

}
		
// LESROOSTER CELLS
function cell_content(data){

	result = '<td>';

	if(data.les_text != ''){ result += data.les_text + '<br />'; }
	if(data.les_id != '' && data.les_id != undefined){ 

		local_lessen.clearFilter();
		local_lessen.filter('les_id', data.les_id);
		rec = local_lessen.first();
		result += '<button onClick="showles(' + rec.data.les_id + ')">' + rec.data.les + '</button><br />';
				
	}
	if(data.info != ''){ result += data.info + '<br />'; }
	if(data.tijd != ''){ result += data.tijd + '<br />'; }
	if(data.opmerking != undefined){ result += '<span style="color: red;">' + data.opmerking + '</span>'; }

	result += '</td>';
			
	return result;
			
}
		
// CREATE LESROOSTER
function create_lesrooster(){

	for (var i=0;i<dagen_array.length;i++){
			

		html =	'<table cellspacing="0" cellpadding="2" border="0" class="lesrooster_table">';
		html +=	'<tr><td class="lesrooster_header"><b>Grote zaal</b></td><td class="lesrooster_header"><b>Beneden zaal</b></td><td class="lesrooster_header"><b>Fitness zaal</b></td></tr>';
			
		local_lesrooster.clearFilter();
		local_lesrooster.filter('dag', dagen_array[i]);
		local_lesrooster.each(function(data){
						
			html += '<tr>';
			html += cell_content(data.data.grote_zaal);
			html += cell_content(data.data.kleine_zaal);
			html += cell_content(data.data.fitness_zaal);
			html += '</tr>';
						
		});
						
		html += '</table>';
						
		Ext.getCmp('content-card').items.get(i).setHtml(html);
	}
			
	// Set current day
	Ext.getCmp('content-card').setActiveItem(current_day);
	Ext.getCmp('dagen').setPressedButtons(current_day);
	
}
		
// CREATE UPDATES
function create_updates(){

	html =	'';
	local_updates.each(function(rec){
		html += '<p style="font-weight: bold; margin-bottom: 0px;">' + rec.data.date + ': ' + rec.data.title + '</p>' + rec.data.content.replace(/\"/g,'"') + '';						
	});
					
	Ext.getCmp('Updates').setHtml(html);

}
		
// CREATE CONTACT
function create_contact(){
	rec = local_contact.first();
	if(rec != undefined){
		Ext.getCmp('Contact').setHtml(rec.data.content.replace(/\"/g,'"'));
	}
}

// SHOW LES
function showles(les_id){
	
	if(popup_opened == 0){

		popup_opened = 1;

		local_lessen.clearFilter();
		local_lessen.filter('les_id', les_id);
		local_lessen.each(function(rec){
			content = '<h3>' + rec.data.les + '</h3>' + rec.data.content.replace(/\"/g,'"');
		});
	
		var pnl = new Ext.Panel({
			width: Ext.os.deviceType == 'Phone' ? 260 : 260,
			height: Ext.os.deviceType == 'Phone' ? 220 : 220,
			centered: true,
			modal: true,
			hideOnMaskTap: true,
			showAnimation: {
				type: 'popIn',
				duration: 250,
				easing: 'ease-out',
			},
			hideAnimation: {
				type: 'popOut',
				duration: 250,
				easing: 'ease-out',
			},
			scrollable: true,
			items:[
				{
					xtype: 'panel',
					layout: 'vbox',
					items: [
						{
							xtype: 'panel',
							styleHtmlContent: false,
							html: content,
							cls: 'default_popup',
							style: {  background: '#EEEEEE' },
						},
						{
							xtype: 'button',
							ui: 'round',
							text: 'Sluiten',
							docked: 'bottom',
							margin: '0 80 20 80',
							cls: 'close_button',
							listeners : {
								tap : function() { pnl.hide(); }
							}
						},
					]
				}
			],
			listeners: {
				'hide': function(){ setTimeout( function(){ popup_opened = 0 }, 500); }
			}
		});
	
		Ext.Viewport.add(pnl);
	}
}

// UPDATE DATA
function update_all(){
			
	// VARS
	lessen_updated = false;
	lesrooster_updated = false;
	updates_updated = false;
	contact_updated = false;
			
	// SET LOADING SCREEN
	Ext.Viewport.setMasked({xtype:'loadmask',message:'Ophalen van nieuwe gegevens'});
			
	// UPDATE LESROOSTER
	remote_lesrooster.load({
		callback: function(data, operation, success) {
			if((success) && (remote_lesrooster.getCount() > 0)){
				delete_old_lesrooster(data);
			}else{
				lesrooster_updated = true;
			}
		}
	});
		
	// UPDATE LESSEN
	remote_lessen.load({
		callback: function(data, operation, success) {
			if((success) && (remote_lessen.getCount() > 0)){
				delete_old_lessen(data);
			}else{
				lessen_updated = true;
			}
		}
	});

	// UPDATE UPDATES
	remote_updates.load({
		callback: function(data, operation, success) {
			if(success){
				delete_old_updates(data);
			}else{
				updates_updated = true;
			}
		}
	});
		
	// UPDATE CONTACT
	remote_contact.load({
		callback: function(data, operation, success) {
			if(success){
				delete_old_contact(data);
			}else{
				contact_updated = true;
			}
		}
	});
					
	// START POLLING FOR COMPLETION
	check_complete = setInterval(function(){
				
		if((lessen_updated) && (lesrooster_updated) && (updates_updated) && (contact_updated)){
		
			// Stop polling
			clearInterval(check_complete);
	
			// Show data
			show_data();
				
			// REMOVE LOADING SCREEN
			Ext.Viewport.setMasked(false);

		}
	}, 100);
}
		
// Show all data
function show_data(){
		
	// Create lesrooster
	create_lesrooster();
	
	// Create updates
	create_updates();
		
	// Create contact
	create_contact();

}

// Check no data
function check_no_data(){

	var content = '<b>Geen gegevens gevonden</b><br /><br />Zet uw dataverbinding aan om de app te vullen met alle gegevens.<br /><br />Bij een actieve dataverbinding kunt u via het updates-scherm automatisch de gegevens bijwerken.';
	var pnl = new Ext.Panel({
		width: 210,
		height: 150,
		centered: true,
		modal: true,
		scrollable: { direction: 'vertical' },
		items:[{
			xtype: 'panel',
			layout: 'vbox',
			cls: 'default_popup',
			items: [{
				xtype: 'panel',
				styleHtmlContent: false,
				html: content,
				cls: 'default_popup',
				docked: 'top',
			},
			{
				xtype: 'button',
				ui: 'round',
				text: 'Sluiten',
				docked: 'bottom',
				margin: '0 80 20 80',
				cls: 'close_button',
				listeners : {
					tap : function() { pnl.hide(); }
				}
			}]
		}]
	});

	// Load local lesrooster
	local_lesrooster.load({
		callback: function(data, operation, success) {
			if(data.length == 0){
					
				// Try to update or show warning
				local_lesrooster.load({
					callback: function(data, operation, success) {
					
						// Update
						if(success){ 
							update_all();
							
						// Warning
						}else{
							Ext.Viewport.add(pnl);		
						}
					}
				});
			}
		}
	});
}
